\documentclass[a4paper, trou]{./tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

  
\graphicspath{{tpl/}{img/}}
\ddmodulename{Computer Science}
\ddmodulenumber{Minidem Tutorial}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien



\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  


\newdemexo{13}{Decorate a Simulation}

\noindent The goal of this tutorial is to show you how to decorate a simulation by adding text and simple geometric shapes. These geometric shapes are called \href{https://matplotlib.org/stable/api/patches_api.html}{patches}. There are various types: ellipse, rectangle, polygon, etc. This tutorial will also show you how to animate these decorative elements during the simulation.

\vspace{0.5cm}

\begin{task}
  Download the module \dldem{minidem.py} and the script
  \dltutodem{13}{tuto-13\_exercice.py}. Run the script
  \dltutodem{13}{tuto-13\_exercice.py}.
\end{task}

\begin{info}
At this point, you should obtain a simulation similar to the video \dltutodem{13}{tuto-13\_exercice.mp4}.
\end{info}

\begin{info}
Observe the \texttt{main} block, where you will see that 2 decorative elements have been added:
\begin{itemize}
\item a \href{https://matplotlib.org/stable/api/text_api.html\#matplotlib.text.Text}{\texttt{matplotlib.text.Text}} object assigned to the variable \texttt{label} which counts and displays the number of collisions between the blue grain and the walls
\item a \href{https://matplotlib.org/stable/api/_as_gen/matplotlib.patches.Rectangle.html}{\texttt{matplotlib.patches.Rectangle}} object assigned to the variable \texttt{rectangle}
\end{itemize}
\end{info}

\begin{center}
  \svgb{1.0\linewidth}{./img/tuto-minidem_13.pdf_tex}
\end{center}


\begin{task}
Disable the title and axes with the following settings. Place these lines in the \texttt{main} block.
\vspace*{-1\baselineskip}
\begin{lstlisting}
dem.simu.custom_title = True
dem.simu.ax.set_xticklabels([])
dem.simu.ax.set_yticklabels([])
\end{lstlisting}
\end{task}


\begin{info}
  The boolean attribute \texttt{visible} of the \texttt{dem.grain} class allows you to make a grain invisible or visible.
\end{info}

\begin{task}
  Modify the \texttt{rigid\_wall()} function to alternately make the blue grain visible and invisible with each collision with the walls.
\end{task}

\begin{info}
  The method \texttt{set\_position(x,y)} of the \href{https://matplotlib.org/stable/api/text_api.html\#matplotlib.text.Text}{\texttt{matplotlib.text.Text}}
  class allows you to change the location of a text.
\end{info}

\begin{task}
  Modify the \texttt{update\_object()} function so that the text "follows" the blue grain. The text should be positioned slightly below the grain.
\end{task}

\begin{info}
  The method \texttt{set\_height(val)} of the \href{https://matplotlib.org/stable/api/_as_gen/matplotlib.patches.Rectangle.html}{\texttt{matplotlib.patches.Rectangle}}
  class allows you to change the height of a rectangle-shaped decorative element.
\end{info}

\begin{task}
  Modify the \texttt{update\_object()} function so that the height of the rectangle increases by 2 with each collision of the blue grain with the walls.
\end{task}

\begin{info}
  At this point, you should obtain a simulation similar to the video \dltutodem{13}{tuto-13\_correction.mp4}.
\end{info}

\end{document}
